program FontForHeroes;

uses
  sysutils,
  graphics,
  classes;

type recinfo = record  //char info
  Unk1 :integer;      //2 unknown 4-bytes signed values
  Width:integer;      //width of char
  Unk2 :integer;
    end;

const Header=32; //offset where char info begins
      Data=4128; //offset where pixel data begins

var fontfile:TMemoryStream;              //file with font
    Images:array[0..255] of recinfo;     //array of info for each char
    i,j:integer;
    CurImage:TBitMap;                    //image of current char
    MainImage:TBitMap;                   //output image
    CurLine:PByteArray;                  //pointer to current line in CurImage
    FontHeight:byte;                     //height of font. 6th byte in the file
begin
//initializing variables
fontfile:=TMemoryStream.Create;
fontfile.LoadFromFile(paramstr(1));
fontfile.Seek(5,soFromBeginning);//loading height
fontfile.Read(fontheight,1);
CurImage:=TBitMap.Create;
CurImage.PixelFormat:=pf8bit;//images stored as 8-bit image
CurImage.Height:=FontHeight;
MainImage:=TBitMap.Create;
  with MainImage do begin
    PixelFormat:=pf24bit;//output file will be 24-bit image
    Height:=FontHeight+22;
    Width:=25*256;
  end;
//end of initializing
fontfile.Seek(Header,soFromBeginning);//seeking to the beginning of char info
for i:=0 to 255 do
  fontfile.Read(Images[i], 12);
fontfile.Seek(Data,soFromBeginning);//seeking to beginning of image data
for i:=0 to 255 do begin
  CurImage.Width:=Images[i].Width;//setting width fo current image
  for j:=0 to FontHeight-1 do begin
    CurLine:=CurImage.ScanLine[j];//getting pointer to the current line
    fontfile.Read(CurLine^,Images[i].Width);//reading data to CurImage
  end;
  MainImage.Canvas.Draw(i*25,0,CurImage);//drawing current image on the main one
  MainImage.Canvas.TextOut(i*25,FontHeight,Chr(i));
end;
MainImage.SaveToFile(ChangeFileExt(paramstr(1),'.bmp'));//saving bitmap
fontfile.Free;
CurImage.Free;
MainImage.Free;
end.
